
;CodeVisionAVR C Compiler V3.31 Evaluation
;(C) Copyright 1998-2017 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Release
;Chip type              : ATtiny2313
;Program type           : Application
;Clock frequency        : 16,000000 MHz
;Memory model           : Tiny
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 32 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': No
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Mode 1
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_TINY_

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU WDTCSR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x00DF
	.EQU __DSTACK_SIZE=0x0020
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD2M
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _owf_flag=R3
	.DEF _DayLight_flag=R4
	.DEF _DayLight_flag_msb=R5
	.DEF _completed_flag=R2
	.DEF _Int_Marker=R7
	.DEF _addition=R8
	.DEF _addition_msb=R9
	.DEF _dobavka=R10
	.DEF _dobavka_msb=R11
	.DEF _compA=R12
	.DEF _compA_msb=R13

;GPIOR0-GPIOR2 INITIALIZATION VALUES
	.EQU __GPIOR0_INIT=0x00
	.EQU __GPIOR1_INIT=0x00
	.EQU __GPIOR2_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP _ext_int1_isr
	RJMP 0x00
	RJMP _timer1_compa_isr
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x1,0x80


__GLOBAL_INI_TBL:
	.DW  0x0C
	.DW  0x02
	.DW  __REG_VARS*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,__CLEAR_SRAM_SIZE
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	;__GPIOR1_INIT = __GPIOR0_INIT
	OUT  GPIOR1,R30
	;__GPIOR2_INIT = __GPIOR0_INIT
	OUT  GPIOR2,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0x00

	.DSEG
	.ORG 0x80

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V1.25.5 Professional
;Automatic Program Generator
; Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 17.04.2008
;Author  : F4CG
;Company : F4CG
;Comments:
;
;
;Chip type           : ATtiny2313
;Clock frequency     : 16,000000 MHz
;Memory model        : Tiny
;External SRAM size  : 0
;Data Stack size     : 32
;*****************************************************/
;
;#include <tiny2313.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdio.h>
;
;#define COEFFICIENT       (0.89)      //      (    ...
;#define EEPROM_VAL        ((COEFFICIENT * 1024.0) + 0.5)      //      ( ...
;
;#define OCCUPIED          0xFC
;#define FREE              0
;#define SET               0xEE
;#define RANGE_250         0x03
;#define RANGE_15          0x05
;#define LIMIT             150 //   , 100 = 1,2 ., 200 = 0,6 .
;#define ISC10             2
;#define START_SET         0x8001
;#define PRESSED           0
;#define NO_PRESSED        1
;#define DAY_LIGHT_DELAY   ((61*60)*1) //    
;
;#define SET_B(x) |=(1<<x)
;#define CLR_B(x) &=~(1<<x)
;#define INV_B(x) ^=(1<<x)
;
;#define DAT_TYPE          (PINB.6)
;#define SOURCE_TYPE       (PINB.7)
;
;#define KNOPA             (PINB.0)
;#define LED               (PORTD.6)
;
;//  
;
;
;#pragma keep+
;eeprom unsigned long version_date = 3102017;
;eeprom unsigned long division_factor = EEPROM_VAL;
;#pragma keep-
;
;unsigned long K_div;
;
;unsigned char owf_flag = 0;
;unsigned int  DayLight_flag = 0;
;
;unsigned char completed_flag = FREE;
;unsigned char Int_Marker = FREE;
;
;unsigned int addition, dobavka = 0;
;unsigned int compA = START_SET;
;unsigned int Int_Start_Time, Int_Stop_Time, Result;
;
;
;//     .
;interrupt [EXT_INT1] void ext_int1_isr(void)    {
; 0000 004A interrupt [3] void ext_int1_isr(void)    {

	.CSEG
_ext_int1_isr:
; .FSTART _ext_int1_isr
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 004B switch (Int_Marker) {
	MOV  R30,R7
; 0000 004C                      case FREE:
	CPI  R30,0
	BRNE _0x6
; 0000 004D                                     Int_Start_Time = TCNT1;
	IN   R30,0x2C
	IN   R31,0x2C+1
	STS  _Int_Start_Time,R30
	STS  _Int_Start_Time+1,R31
; 0000 004E                                     Int_Marker = OCCUPIED;
	LDI  R30,LOW(252)
	MOV  R7,R30
; 0000 004F                                     TCNT0 = 0;   //   0
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 0050                                     owf_flag = 0; //   
	CLR  R3
; 0000 0051                                     break;
	RJMP _0x5
; 0000 0052                      case OCCUPIED:
_0x6:
	CPI  R30,LOW(0xFC)
	BRNE _0x5
; 0000 0053                                     Int_Stop_Time = TCNT1;
	IN   R30,0x2C
	IN   R31,0x2C+1
	STS  _Int_Stop_Time,R30
	STS  _Int_Stop_Time+1,R31
; 0000 0054                                     Int_Marker = SET;
	LDI  R30,LOW(238)
	MOV  R7,R30
; 0000 0055                                     TIMSK SET_B(6);
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
; 0000 0056                                     break;
; 0000 0057      }
_0x5:
; 0000 0058 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
; .FEND
;
;
;void reset_variables (void) {
; 0000 005B void reset_variables (void) {
_reset_variables:
; .FSTART _reset_variables
; 0000 005C 
; 0000 005D     Int_Marker = FREE;
	CLR  R7
; 0000 005E     completed_flag = FREE;   // ,     .
	CLR  R2
; 0000 005F     TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 0060     TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0061 //    Result = 0;
; 0000 0062 //    OCR1AH=(START_SET>>8);
; 0000 0063 //    OCR1AL=(START_SET & 0xFF);
; 0000 0064     compA = START_SET;
	LDI  R30,LOW(32769)
	LDI  R31,HIGH(32769)
	MOVW R12,R30
; 0000 0065 
; 0000 0066 }
	RET
; .FEND
;
;
;//     0.
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)      {
; 0000 006A interrupt [7] void timer0_ovf_isr(void)      {
_timer0_ovf_isr:
; .FSTART _timer0_ovf_isr
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 006B   owf_flag++; //   
	INC  R3
; 0000 006C   if(owf_flag > LIMIT) {
	LDI  R30,LOW(150)
	CP   R30,R3
	BRSH _0x8
; 0000 006D                         owf_flag = 0;
	CLR  R3
; 0000 006E                         reset_variables();
	RCALL _reset_variables
; 0000 006F                         TIMSK CLR_B(6); //   ,   Compare A Match
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
; 0000 0070                        }
; 0000 0071 
; 0000 0072      if(DayLight_flag) { DayLight_flag--;  }
_0x8:
	MOV  R0,R4
	OR   R0,R5
	BREQ _0x9
	MOVW R30,R4
	SBIW R30,1
	MOVW R4,R30
; 0000 0073                   else { PORTB &= ~(1<<1); Result = 0;  }  //  
	RJMP _0xA
_0x9:
	CBI  0x18,1
	LDI  R30,LOW(0)
	STS  _Result,R30
	STS  _Result+1,R30
_0xA:
; 0000 0074 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; .FEND
;
;
;//  ,     ,   OCR1A.
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)    {
; 0000 0078 interrupt [5] void timer1_compa_isr(void)    {
_timer1_compa_isr:
; .FSTART _timer1_compa_isr
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0079 
; 0000 007A  PORTD INV_B(4);
	IN   R30,0x12
	LDI  R26,LOW(16)
	EOR  R30,R26
	OUT  0x12,R30
; 0000 007B 
; 0000 007C   if(completed_flag == SET)  {
	LDI  R30,LOW(238)
	CP   R30,R2
	BRNE _0xB
; 0000 007D                              addition = dobavka;      //   ,   temp
	MOVW R8,R10
; 0000 007E                              completed_flag = FREE;   //  ,   
	CLR  R2
; 0000 007F                              }
; 0000 0080 
; 0000 0081    compA += addition;
_0xB:
	__ADDWRR 12,13,8,9
; 0000 0082    OCR1A = compA;
	__OUTWR 12,13,42
; 0000 0083 
; 0000 0084 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	RETI
; .FEND
;
;
;void Measurement(void) {
; 0000 0087 void Measurement(void) {
_Measurement:
; .FSTART _Measurement
; 0000 0088 
; 0000 0089    Result = ((Int_Stop_Time - Int_Start_Time) & 0xFFFF);
	LDS  R26,_Int_Start_Time
	LDS  R27,_Int_Start_Time+1
	LDS  R30,_Int_Stop_Time
	LDS  R31,_Int_Stop_Time+1
	SUB  R30,R26
	SBC  R31,R27
	STS  _Result,R30
	STS  _Result+1,R31
; 0000 008A 
; 0000 008B }
	RET
; .FEND
;
;
;
;void Basis_cycle(void) {
; 0000 008F void Basis_cycle(void) {
_Basis_cycle:
; .FSTART _Basis_cycle
; 0000 0090 //unsigned long LongResult;
; 0000 0091 
; 0000 0092        #asm("wdr")  //   
	WDR
; 0000 0093 
; 0000 0094        if(Int_Marker == SET) {   //   INT1 ...
	LDI  R30,LOW(238)
	CP   R30,R7
	BREQ PC+2
	RJMP _0xC
; 0000 0095 
; 0000 0096             Measurement();  //    
	RCALL _Measurement
; 0000 0097 
; 0000 0098        Int_Marker = FREE;           // ,    .
	CLR  R7
; 0000 0099 
; 0000 009A             if( Result < 50 ) return;
	LDS  R26,_Result
	LDS  R27,_Result+1
	SBIW R26,50
	BRSH _0xD
	RET
; 0000 009B 
; 0000 009C                 //   ,   
; 0000 009D                 PORTB |=  (1<<1);
_0xD:
	SBI  0x18,1
; 0000 009E                 DayLight_flag = DAY_LIGHT_DELAY;
	LDI  R30,LOW(3660)
	LDI  R31,HIGH(3660)
	MOVW R4,R30
; 0000 009F 
; 0000 00A0 
; 0000 00A1       if((TCCR1B == RANGE_250) && (Result > 31000) ) { //    ,  ;
	IN   R30,0x2E
	CPI  R30,LOW(0x3)
	BRNE _0xF
	LDS  R26,_Result
	LDS  R27,_Result+1
	CPI  R26,LOW(0x7919)
	LDI  R30,HIGH(0x7919)
	CPC  R27,R30
	BRSH _0x10
_0xF:
	RJMP _0xE
_0x10:
; 0000 00A2                                                       TCCR1B = RANGE_15;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
; 0000 00A3                                                       addition = addition*16; //   16
	MOVW R30,R8
	RCALL __LSLW4
	MOVW R8,R30
; 0000 00A4                                                       reset_variables();
	RCALL _reset_variables
; 0000 00A5                                                       return;
	RET
; 0000 00A6                                                      }
; 0000 00A7 
; 0000 00A8       if((TCCR1B == RANGE_15) && (Result < 1200) )   { //     13 ,  ;
_0xE:
	IN   R30,0x2E
	CPI  R30,LOW(0x5)
	BRNE _0x12
	LDS  R26,_Result
	LDS  R27,_Result+1
	CPI  R26,LOW(0x4B0)
	LDI  R30,HIGH(0x4B0)
	CPC  R27,R30
	BRLO _0x13
_0x12:
	RJMP _0x11
_0x13:
; 0000 00A9                                                       addition = addition/16; //   16
	MOVW R30,R8
	RCALL __LSRW4
	MOVW R8,R30
; 0000 00AA                                                       reset_variables();
	RCALL _reset_variables
; 0000 00AB                                                       TCCR1B = RANGE_250;
	LDI  R30,LOW(3)
	OUT  0x2E,R30
; 0000 00AC                                                       return;
	RET
; 0000 00AD                                                      }
; 0000 00AE 
; 0000 00AF 
; 0000 00B0           dobavka = (unsigned int)( ( (unsigned long)Result << 9 ) / K_div); // Result   long,   ...
_0x11:
	LDS  R26,_Result
	LDS  R27,_Result+1
	CLR  R24
	CLR  R25
	LDI  R30,LOW(9)
	RCALL __LSLD12
	MOVW R26,R30
	MOVW R24,R22
	LDS  R30,_K_div
	LDS  R31,_K_div+1
	LDS  R22,_K_div+2
	LDS  R23,_K_div+3
	RCALL __DIVD21U
	MOVW R10,R30
; 0000 00B1 
; 0000 00B2           completed_flag = SET; //     ,     completed_flag.
	LDI  R30,LOW(238)
	MOV  R2,R30
; 0000 00B3 
; 0000 00B4 
; 0000 00B5           } // end of "if(Int_Marker == SET)"
; 0000 00B6 }
_0xC:
	RET
; .FEND
;
;
;
;
;void nakrutka(void) { //   ,  
; 0000 00BB void nakrutka(void) {
_nakrutka:
; .FSTART _nakrutka
; 0000 00BC unsigned int counter;
; 0000 00BD unsigned char numi;
; 0000 00BE //unsigned char buf[6];
; 0000 00BF //float temp32 = 0.0;
; 0000 00C0 
; 0000 00C1 counter = 0;
	RCALL __SAVELOCR4
;	counter -> R16,R17
;	numi -> R19
	__GETWRN 16,17,0
; 0000 00C2 while ( (counter < 2000) && (KNOPA == PRESSED) ) {  //    ,  2 .
_0x14:
	__CPWRN 16,17,2000
	BRSH _0x17
	SBIS 0x16,0
	RJMP _0x18
_0x17:
	RJMP _0x16
_0x18:
; 0000 00C3                                            counter++;
	__ADDWRN 16,17,1
; 0000 00C4                                            #asm("wdr")  //   
	WDR
; 0000 00C5                                            delay_ms(1);
	LDI  R26,LOW(1)
	LDI  R27,0
	RCALL _delay_ms
; 0000 00C6                                            }
	RJMP _0x14
_0x16:
; 0000 00C7           if( counter < 2000 ) return;  //  -   - 
	__CPWRN 16,17,2000
	BRLO _0x2060002
; 0000 00C8 
; 0000 00C9           LED = 1; //  
	SBI  0x12,6
; 0000 00CA 
; 0000 00CB           while (KNOPA == PRESSED) { #asm("wdr") } //   
_0x1C:
	SBIC 0x16,0
	RJMP _0x1E
	WDR
	RJMP _0x1C
_0x1E:
; 0000 00CC           delay_ms(250); // 
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
; 0000 00CD             if(KNOPA == PRESSED) { //      - 
	SBIS 0x16,0
; 0000 00CE                                   LED = 0; //  
	RJMP _0x2060001
; 0000 00CF                                   return;
; 0000 00D0                                  }
; 0000 00D1 
; 0000 00D2 // ***    ,            . ***
; 0000 00D3      //  TIMSK=0; //  
; 0000 00D4 
; 0000 00D5                         Int_Marker = FREE;
	CLR  R7
; 0000 00D6                         completed_flag = FREE;   // ,     .
	CLR  R2
; 0000 00D7                        // owf_flag = 0;
; 0000 00D8                         TIMSK CLR_B(6); //   ,   Compare A Match
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
; 0000 00D9 
; 0000 00DA        while (KNOPA == NO_PRESSED) {
_0x22:
	SBIS 0x16,0
	RJMP _0x24
; 0000 00DB        #asm("wdr")  //   
	WDR
; 0000 00DC        for (numi=0;numi<250;numi++) {
	LDI  R19,LOW(0)
_0x26:
	CPI  R19,250
	BRSH _0x27
; 0000 00DD             PORTD ^= (1<<4); // inv OUT
	IN   R30,0x12
	LDI  R26,LOW(16)
	EOR  R30,R26
	OUT  0x12,R30
; 0000 00DE             delay_ms(2);
	LDI  R26,LOW(2)
	LDI  R27,0
	RCALL _delay_ms
; 0000 00DF             #asm("wdr")
	WDR
; 0000 00E0            }
	SUBI R19,-1
	RJMP _0x26
_0x27:
; 0000 00E1        PORTD ^= (1<<6); // inv LED
	IN   R30,0x12
	LDI  R26,LOW(64)
	EOR  R30,R26
	OUT  0x12,R30
; 0000 00E2        }
	RJMP _0x22
_0x24:
; 0000 00E3 
; 0000 00E4 
; 0000 00E5  PORTD &= ~(1<<4); //   
	CBI  0x12,4
; 0000 00E6  LED = 0;
_0x2060001:
	CBI  0x12,6
; 0000 00E7 
; 0000 00E8  return;
_0x2060002:
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
; 0000 00E9 }
; .FEND
;
;void main(void)
; 0000 00EC {
_main:
; .FSTART _main
; 0000 00ED // Declare your local variables here
; 0000 00EE 
; 0000 00EF // Crystal Oscillator division factor: 1
; 0000 00F0 #pragma optsize-
; 0000 00F1 CLKPR=0x80;
	LDI  R30,LOW(128)
	OUT  0x26,R30
; 0000 00F2 CLKPR=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 00F3 #ifdef _OPTIMIZE_SIZE_
; 0000 00F4 #pragma optsize+
; 0000 00F5 #endif
; 0000 00F6 
; 0000 00F7 // Input/Output Ports initialization
; 0000 00F8 // Port A initialization
; 0000 00F9 // Func2=In Func1=Out Func0=In
; 0000 00FA // State2=P State1=0 State0=T
; 0000 00FB PORTA=0x04;
	LDI  R30,LOW(4)
	OUT  0x1B,R30
; 0000 00FC DDRA=0x02;
	LDI  R30,LOW(2)
	OUT  0x1A,R30
; 0000 00FD 
; 0000 00FE // Port B initialization
; 0000 00FF // Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=In
; 0000 0100 // State7=P State6=P State5=0 State4=0 State3=0 State2=0 State1=0 State0=T
; 0000 0101 PORTB = (0xC0 | (1<<0)); //   0  .
	LDI  R30,LOW(193)
	OUT  0x18,R30
; 0000 0102 DDRB  =  0x3E;
	LDI  R30,LOW(62)
	OUT  0x17,R30
; 0000 0103 
; 0000 0104 // Port D initialization
; 0000 0105 // Func6=Out Func5=Out Func4=Out Func3=In Func2=Out Func1=Out Func0=In
; 0000 0106 // State6=0 State5=1 State4=0 State3=T State2=0 State1=0 State0=T
; 0000 0107 PORTD=0x20;
	LDI  R30,LOW(32)
	OUT  0x12,R30
; 0000 0108 DDRD=0x76;
	LDI  R30,LOW(118)
	OUT  0x11,R30
; 0000 0109 
; 0000 010A // Timer/Counter 0 initialization
; 0000 010B // Clock source: System Clock
; 0000 010C // Clock value: 15,625 kHz
; 0000 010D // Mode: Normal top=FFh
; 0000 010E // OC0A output: Disconnected
; 0000 010F // OC0B output: Disconnected
; 0000 0110 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0111 TCCR0B=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 0112 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 0113 OCR0A=0x00;
	OUT  0x36,R30
; 0000 0114 OCR0B=0x00;
	OUT  0x3C,R30
; 0000 0115 
; 0000 0116 // Timer/Counter 1 initialization
; 0000 0117 // Clock source: System Clock
; 0000 0118 // Clock value: 15,625 kHz
; 0000 0119 // Mode: Normal top=FFFFh
; 0000 011A // OC1A output: Discon.
; 0000 011B // OC1B output: Discon.
; 0000 011C // Noise Canceler: Off
; 0000 011D // Input Capture on Falling Edge
; 0000 011E // Timer 1 Overflow Interrupt: On
; 0000 011F // Input Capture Interrupt: Off
; 0000 0120 // Compare A Match Interrupt: On
; 0000 0121 // Compare B Match Interrupt: Off
; 0000 0122 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0123 TCCR1B=RANGE_15;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
; 0000 0124 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 0125 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0126 ICR1H=0x00;
	OUT  0x25,R30
; 0000 0127 ICR1L=0x00;
	OUT  0x24,R30
; 0000 0128 OCR1AH=(START_SET>>8);
	LDI  R30,LOW(128)
	OUT  0x2B,R30
; 0000 0129 OCR1AL=(START_SET & 0xFF);
	LDI  R30,LOW(1)
	OUT  0x2A,R30
; 0000 012A OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
; 0000 012B OCR1BL=0x00;
	OUT  0x28,R30
; 0000 012C 
; 0000 012D // External Interrupt(s) initialization
; 0000 012E // INT0: Off
; 0000 012F // INT1: On
; 0000 0130 // INT1 Mode: Falling Edge
; 0000 0131 // Interrupt on any change on pins PCINT0-7: Off
; 0000 0132 GIMSK=0x80;
	LDI  R30,LOW(128)
	OUT  0x3B,R30
; 0000 0133 MCUCR=0x08;
	LDI  R30,LOW(8)
	OUT  0x35,R30
; 0000 0134 EIFR=0x80;
	LDI  R30,LOW(128)
	OUT  0x3A,R30
; 0000 0135 
; 0000 0136 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0137 TIMSK=0x42;
	LDI  R30,LOW(66)
	OUT  0x39,R30
; 0000 0138 TIMSK CLR_B(6); //    .
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
; 0000 0139 
; 0000 013A // Universal Serial Interface initialization
; 0000 013B // Mode: Disabled
; 0000 013C // Clock source: Register & Counter=no clk.
; 0000 013D // USI Counter Overflow Interrupt: Off
; 0000 013E USICR=0x00;
	LDI  R30,LOW(0)
	OUT  0xD,R30
; 0000 013F 
; 0000 0140 // Analog Comparator initialization
; 0000 0141 // Analog Comparator: Off
; 0000 0142 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0143 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0144 
; 0000 0145 // Watchdog Timer initialization
; 0000 0146 // Watchdog Timer Prescaler: OSC/1024k
; 0000 0147 // Watchdog Timer interrupt: Off
; 0000 0148 #pragma optsize-
; 0000 0149 WDTCR=0x39;
	LDI  R30,LOW(57)
	OUT  0x21,R30
; 0000 014A WDTCR=0x29;
	LDI  R30,LOW(41)
	OUT  0x21,R30
; 0000 014B #ifdef _OPTIMIZE_SIZE_
; 0000 014C #pragma optsize+
; 0000 014D #endif
; 0000 014E 
; 0000 014F 
; 0000 0150 
; 0000 0151 K_div = division_factor;
	LDI  R26,LOW(_division_factor)
	LDI  R27,HIGH(_division_factor)
	RCALL __EEPROMRDD
	STS  _K_div,R30
	STS  _K_div+1,R31
	STS  _K_div+2,R22
	STS  _K_div+3,R23
; 0000 0152 
; 0000 0153 // Global enable interrupts
; 0000 0154 #asm("sei")
	SEI
; 0000 0155 
; 0000 0156 while (1)
_0x2A:
; 0000 0157       {
; 0000 0158       if(KNOPA == PRESSED) { nakrutka(); }
	SBIS 0x16,0
	RCALL _nakrutka
; 0000 0159       Basis_cycle();
	RCALL _Basis_cycle
; 0000 015A       }
	RJMP _0x2A
; 0000 015B }
_0x2E:
	RJMP _0x2E
; .FEND
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.ESEG
_version_date:
	.DB  0x41,0x55,0x2F,0x0
_division_factor:
	.DB  0x8F,0x3,0x0,0x0

	.DSEG
_K_div:
	.BYTE 0x4
_Int_Start_Time:
	.BYTE 0x2
_Int_Stop_Time:
	.BYTE 0x2
_Result:
	.BYTE 0x2

	.CSEG
;RUNTIME LIBRARY

	.CSEG
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LSLD12:
	TST  R30
	MOV  R0,R30
	LDI  R30,8
	MOV  R1,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12S8:
	CP   R0,R1
	BRLO __LSLD12L
	MOV  R23,R22
	MOV  R22,R31
	MOV  R31,R30
	LDI  R30,0
	SUB  R0,R1
	BRNE __LSLD12S8
	RET
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__LSRW4:
	LSR  R31
	ROR  R30
__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	MOVW R20,R0
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__EEPROMRDD:
	ADIW R26,2
	RCALL __EEPROMRDW
	MOVW R22,R30
	SBIW R26,2

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	wdr
	__DELAY_USW 0xFA0
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

;END OF CODE MARKER
__END_OF_CODE:
