
#pragma used+
sfrb DIDR=1;
sfrb UBRRH=2;
sfrb UCSRC=3;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb USICR=0xd;
sfrb USISR=0xe;
sfrb USIDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb GPIOR0=0x13;
sfrb GPIOR1=0x14;
sfrb GPIOR2=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb PCMSK=0x20;
sfrb WDTCR=0x21;
sfrb TCCR1C=0x22;
sfrb GTCCR=0x23;
sfrb ICR1L=0x24;
sfrb ICR1H=0x25;
sfrw ICR1=0x24;   
sfrb CLKPR=0x26;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;   
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;   
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCCR0A=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb EIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb OCR0B=0x3c;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);

void putchar(char c);

void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned char len);
int snprintf(char *str, unsigned char size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned char size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma keep+
eeprom unsigned long version_date = 3102017;
eeprom unsigned long division_factor = (((0.89)       * 1024.0) + 0.5)      ;
#pragma keep-

unsigned long K_div;

unsigned char owf_flag = 0;  
unsigned int  DayLight_flag = 0;  

unsigned char completed_flag = 0; 
unsigned char Int_Marker = 0;

unsigned int addition, dobavka = 0; 
unsigned int compA = 0x8001    ;
unsigned int Int_Start_Time, Int_Stop_Time, Result; 

interrupt [3] void ext_int1_isr(void)    {   
switch (Int_Marker) {
case 0:      
Int_Start_Time = TCNT1; 
Int_Marker = 0xFC;  
TCNT0 = 0;   
owf_flag = 0; 
break;
case 0xFC: 
Int_Stop_Time = TCNT1; 
Int_Marker = 0xEE  ; 
TIMSK |=(1<<6) ;
break;
} 
}

void reset_variables (void) {

Int_Marker = 0; 
completed_flag = 0;   
TCNT1H=0x00;
TCNT1L=0x00; 
compA = 0x8001    ;

}

interrupt [7] void timer0_ovf_isr(void)      {
owf_flag++; 
if(owf_flag > 150 ) { 
owf_flag = 0;   
reset_variables();
TIMSK &=~(1<<6) ; 
}

if(DayLight_flag) { DayLight_flag--;  }
else { PORTB &= ~(1<<1); Result = 0;  }  
}

interrupt [5] void timer1_compa_isr(void)    {

PORTD ^=(1<<4)   ;  

if(completed_flag == 0xEE  )  {
addition = dobavka;      
completed_flag = 0;   
}

compA += addition;   
OCR1A = compA;   

} 

void Measurement(void) { 

Result = ((Int_Stop_Time - Int_Start_Time) & 0xFFFF);

}      

void Basis_cycle(void) {  

#asm("wdr")  

if(Int_Marker == 0xEE  ) {   

Measurement();  

Int_Marker = 0;           

if( Result < 50 ) return;     

PORTB |=  (1<<1); 
DayLight_flag = ((61*60)*1) ; 

if((TCCR1B == 0x03) && (Result > 31000) ) { 
TCCR1B = 0x05; 
addition = addition*16; 
reset_variables();
return;
}  

if((TCCR1B == 0x05) && (Result < 1200) )   { 
addition = addition/16; 
reset_variables();
TCCR1B = 0x03;  
return;
}

dobavka = (unsigned int)( ( (unsigned long)Result << 9 ) / K_div); 

completed_flag = 0xEE  ; 

} 
}

void nakrutka(void) { 
unsigned int counter; 
unsigned char numi;

counter = 0;
while ( (counter < 2000) && ((PINB.0) == 0) ) {  
counter++; 
#asm("wdr")  
delay_ms(1);
}
if( counter < 2000 ) return;  

(PORTD.6) = 1; 

while ((PINB.0) == 0) { #asm("wdr") } 
delay_ms(250); 
if((PINB.0) == 0) { 
(PORTD.6) = 0; 
return; 
}  

Int_Marker = 0; 
completed_flag = 0;   
TIMSK &=~(1<<6) ; 

while ((PINB.0) == 1) {
#asm("wdr")  
for (numi=0;numi<250;numi++) {
PORTD ^= (1<<4); 
delay_ms(2);
#asm("wdr")
}
PORTD ^= (1<<6); 
}

PORTD &= ~(1<<4); 
(PORTD.6) = 0; 

return;
}

void main(void)
{

#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;

PORTA=0x04;
DDRA=0x02;

PORTB = (0xC0 | (1<<0)); 
DDRB  =  0x3E;

PORTD=0x20;
DDRD=0x76;

TCCR0A=0x00;
TCCR0B=0x05;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=(0x8001    >>8);
OCR1AL=(0x8001     & 0xFF);
OCR1BH=0x00;
OCR1BL=0x00;

GIMSK=0x80;
MCUCR=0x08;
EIFR=0x80;

TIMSK=0x42;
TIMSK &=~(1<<6) ; 

USICR=0x00;

ACSR=0x80;

#pragma optsize-
WDTCR=0x39;
WDTCR=0x29;

K_div = division_factor;

#asm("sei")

while (1)
{ 
if((PINB.0) == 0) { nakrutka(); }
Basis_cycle();
}
}
