/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.5 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :
Version :
Date    : 17.04.2008
Author  : F4CG
Company : F4CG
Comments:


Chip type           : ATtiny2313
Clock frequency     : 16,000000 MHz
Memory model        : Tiny
External SRAM size  : 0
Data Stack size     : 32
*****************************************************/

#include <tiny2313.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>
#include <stdio.h>

#define EEPROM_VAL          (0.5)      //      (   )
#define FLASH_VAL           (2.5)      //  ,    .

#define OCCUPIED          0xFC
#define FREE              0
#define SET               0xEE
#define RANGE_250         0x03
#define RANGE_15          0x05
#define LIMIT             253
#define ISC10             2
#define START_SET         0x8001
#define PRESSED           0
#define NO_PRESSED        1

#define SET_B(x) |=(1<<x)
#define CLR_B(x) &=~(1<<x)
#define INV_B(x) ^=(1<<x)

#define DAT_TYPE          (PINB.6)
#define SOURCE_TYPE       (PINB.7)

#define KNOPA             (PINB.0)
#define LED               (PORTD.6)

//  

eeprom float division_factor = EEPROM_VAL;

float K_div;

unsigned char  owf_flag = 0;

unsigned char completed_flag = FREE;
unsigned char Int_Marker = FREE;

unsigned int temp, dobavka = 0;
unsigned int compA = START_SET;
unsigned int Int_Start_Time, Int_Stop_Time, Result;

///unsigned char i;


//     .
interrupt [EXT_INT1] void ext_int1_isr(void)
{
switch (Int_Marker) {
                     case FREE:
                                    Int_Start_Time = TCNT1;
                                    Int_Marker = OCCUPIED;
                                    TCNT0 = 0;   //   0
                                    owf_flag = 0; //   
                                    break;
                     case OCCUPIED:
                                    Int_Stop_Time = TCNT1;
                                    Int_Marker = SET;
                                    TIMSK SET_B(6);
                                    break;
     }
}


//     0.
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
  owf_flag++; //   
  if(owf_flag > LIMIT) {
                        Int_Marker = FREE;
                        completed_flag = FREE;   // ,     .
                        owf_flag = 0;
                        TIMSK CLR_B(6); //   ,   Compare A Match
                       }
}


//  ,     ,   OCR1A.
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
 PORTD INV_B(4);

  if(completed_flag == SET)  {
                             temp = dobavka;          //   ,   temp
                             completed_flag = FREE;   //  ,   
                             }


  if((compA + temp) > 0xFFFF ) {  // ,           FFFF
                                   compA = ((compA + temp) - 0xFFFF); //  ,     .
                        } else {
                                   compA =  (compA + temp);   //   -  .
                               }
   OCR1A = compA;   //      .

}


void Measurement(void) {

           if(Int_Start_Time < Int_Stop_Time) {
                                               Result = Int_Stop_Time - Int_Start_Time;
                                              }
                                         else {
                                               Result = (0xFFFF - Int_Start_Time) + Int_Stop_Time;
                                              }

      Int_Marker = FREE;           // ,    .
}



void Basis_cycle(void) {
        #asm("wdr")  //   

       if(Int_Marker == SET) {   //   INT1 ...

       Measurement();  //    


         dobavka = (unsigned int)( ((unsigned long)(Result / K_div) + 1)  >> 1);


      if((TCCR1B == RANGE_250) && (Result > 31000) ) { //    ,  ;
                                                      TCCR1B = RANGE_15;
                                                      dobavka = dobavka*16; //   16
                                                     }

      if((TCCR1B == RANGE_15) && (Result < 1200) )  { //    ,  ;
                                                     TCCR1B = RANGE_250;
                                                     dobavka = dobavka/16; //   16
                                                    }

          completed_flag = SET; //     ,     completed_flag.


          } // end of "if(Int_Marker == SET)"
}


char Start_of_calibration(void) { //   ,  
unsigned int counter;
unsigned char num;
unsigned char buf[6];
float temp32 = 0.0;

counter = 0;

while ( (counter < 2000) && (KNOPA == PRESSED) ) {  //    ,  2 .
                                           counter++;
                                           #asm("wdr")  //   
                                           delay_ms(1);
                                           }
          if( counter < 2000 ) return;  //  -   - 

          LED = 1; //  

          while (KNOPA == PRESSED) { #asm("wdr") } //   
          delay_ms(250); // 
            if(KNOPA == PRESSED) { //      - 
                                  LED = 0; //  
                                  return;
                                 }

// ***    ,            . ***


         if( SOURCE_TYPE == 1 ) {  //    ( ),     .

         K_div = 1.0; //    
            #asm("sei")
            while (KNOPA == NO_PRESSED) { //    ...
                                          Basis_cycle(); //..    .
                                        }

               LED = 0; //  
               while(Int_Marker != SET) { #asm("wdr") } //     
            #asm("cli")
              TIMSK CLR_B(6); //    Compare A Match,   

            Measurement();  //    

            if(DAT_TYPE == 1)  { counter = 1497; }  // 10-. 
                         else  { counter = 2500; }  // 6-. 

                          temp32 = (float)(counter / Result);

                             } else {     //    -    UART

                             // USART initialization
                             // Communication Parameters: 8 Data, 1 Stop, No Parity
                             // USART Receiver: On
                             // USART Transmitter: Off
                             // USART Mode: Asynchronous
                             // USART Baud Rate: 19200
                                    UCSRA=0x00;
                                    UCSRB=0x10;
                                    UCSRC=0x06;
                                    UBRRH=0x00;
                                    UBRRL=0x33;

                                    buf[0] = getchar();
                                    buf[1] = getchar();
                                    buf[2] = getchar();
                                    buf[3] = getchar();
                                    buf[4] = getchar();
                                    buf[5] = getchar();

                                 LED = 0; //  

                                    if((buf[0] == 0xA5) && (buf[5] == 0x5A) ) {
                                                                               temp32 = *(float*)(&(buf[1]));   //     temp32
                                                                              }
                                    UCSRB=0x00;  //  UART
                                    }

            if((temp32 > 0.30)&&(temp32 <= 3.0)) { //     ,    .
                                                  division_factor = temp32;
                                                 }
                                            else {
                                                   #asm("wdr")                 // ... .
                                                   LED = 0; //  
                                                   return;
                                                 }


// ***     -   3 . ***

num = 6;
while (num) {
             PORTD INV_B(6);  //   .
             num--;
             #asm("wdr")  //   
             delay_ms(1000);
            }
 LED = 0; //  
 return;
}


void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port A initialization
// Func2=In Func1=Out Func0=In
// State2=P State1=0 State0=T
PORTA=0x04;
DDRA=0x02;

// Port B initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=In
// State7=P State6=P State5=0 State4=0 State3=0 State2=0 State1=0 State0=T
PORTB=0xC0;
DDRB=0x3E;

// Port D initialization
// Func6=Out Func5=Out Func4=Out Func3=In Func2=Out Func1=Out Func0=In
// State6=0 State5=1 State4=0 State3=T State2=0 State1=0 State0=T
PORTD=0x20;
DDRD=0x76;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x05;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 250,000 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x03;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=(START_SET>>8);
OCR1AL=(START_SET & 0xFF);
OCR1BH=0x00;
OCR1BL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: On
// INT1 Mode: Falling Edge
// Interrupt on any change on pins PCINT0-7: Off
GIMSK=0x80;
MCUCR=0x08;
EIFR=0x80;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x42;
TIMSK CLR_B(6); //    .

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
USICR=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/1024k
// Watchdog Timer interrupt: Off
#pragma optsize-
WDTCR=0x39;
WDTCR=0x29;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif


if(KNOPA == PRESSED) { Start_of_calibration(); } //    -   

 /*
if( SOURCE_TYPE == 1 ) { K_div = division_factor; } //    ( ),    
                  else { K_div = FLASH_VAL; }            //    -   .
*/

K_div = division_factor;  //    


// Global enable interrupts
#asm("sei")

while (1)
      {
      Basis_cycle();
      }
}
