
;CodeVisionAVR C Compiler V1.25.5 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATtiny2313
;Clock frequency        : 16,000000 MHz
;Memory model           : Tiny
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 32 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "odometr.vec"
	.INCLUDE "odometr.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.5 Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project :
;       9 Version :
;      10 Date    : 17.04.2008
;      11 Author  : F4CG
;      12 Company : F4CG
;      13 Comments:
;      14 
;      15 
;      16 Chip type           : ATtiny2313
;      17 Clock frequency     : 16,000000 MHz
;      18 Memory model        : Tiny
;      19 External SRAM size  : 0
;      20 Data Stack size     : 32
;      21 *****************************************************/
;      22 
;      23 #include <tiny2313.h>
;      24 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      25 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      26 	.EQU __se_bit=0x20
	.EQU __se_bit=0x20
;      27 	.EQU __sm_mask=0x50
	.EQU __sm_mask=0x50
;      28 	.EQU __sm_powerdown=0x10
	.EQU __sm_powerdown=0x10
;      29 	.EQU __sm_standby=0x40
	.EQU __sm_standby=0x40
;      30 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      31 	#endif
	#endif
;      32 #include <delay.h>
;      33 #include <stdio.h>
;      34 
;      35 #define EEPROM_VAL          (0.5)      //      (   )
;      36 #define FLASH_VAL           (2.5)      //  ,    .
;      37 
;      38 #define OCCUPIED          0xFC
;      39 #define FREE              0
;      40 #define SET               0xEE
;      41 #define RANGE_250         0x03
;      42 #define RANGE_15          0x05
;      43 #define LIMIT             253
;      44 #define ISC10             2
;      45 #define START_SET         0x8001
;      46 #define PRESSED           0
;      47 #define NO_PRESSED        1
;      48 
;      49 #define SET_B(x) |=(1<<x)
;      50 #define CLR_B(x) &=~(1<<x)
;      51 #define INV_B(x) ^=(1<<x)
;      52 
;      53 #define DAT_TYPE          (PINB.6)
;      54 #define SOURCE_TYPE       (PINB.7)
;      55 
;      56 #define KNOPA             (PINB.0)
;      57 #define LED               (PORTD.6)
;      58 
;      59 //  
;      60 
;      61 eeprom float division_factor = EEPROM_VAL;

	.ESEG
_division_factor:
	.DW  0x0
	.DW  0x3F00
;      62 
;      63 float K_div;

	.DSEG
_K_div:
	.BYTE 0x4
;      64 
;      65 unsigned char  owf_flag = 0;
;      66 
;      67 unsigned char completed_flag = FREE;
;      68 unsigned char Int_Marker = FREE;
;      69 
;      70 unsigned int temp, dobavka = 0;
;      71 unsigned int compA = START_SET;
;      72 unsigned int Int_Start_Time, Int_Stop_Time, Result;
_Int_Stop_Time:
	.BYTE 0x2
_Result:
	.BYTE 0x2
;      73 
;      74 ///unsigned char i;
;      75 
;      76 
;      77 //     .
;      78 interrupt [EXT_INT1] void ext_int1_isr(void)
;      79 {

	.CSEG
_ext_int1_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      80 switch (Int_Marker) {
	MOV  R30,R5
;      81                      case FREE:
	CPI  R30,0
	BRNE _0x7
;      82                                     Int_Start_Time = TCNT1;
	__INWR 12,13,44
;      83                                     Int_Marker = OCCUPIED;
	LDI  R30,LOW(252)
	MOV  R5,R30
;      84                                     TCNT0 = 0;   //   0
	LDI  R30,LOW(0)
	OUT  0x32,R30
;      85                                     owf_flag = 0; //   
	CLR  R3
;      86                                     break;
	RJMP _0x6
;      87                      case OCCUPIED:
_0x7:
	CPI  R30,LOW(0xFC)
	BRNE _0x6
;      88                                     Int_Stop_Time = TCNT1;
	IN   R30,0x2C
	IN   R31,0x2C+1
	STS  _Int_Stop_Time,R30
	STS  _Int_Stop_Time+1,R31
;      89                                     Int_Marker = SET;
	LDI  R30,LOW(238)
	MOV  R5,R30
;      90                                     TIMSK SET_B(6);
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
;      91                                     break;
;      92      }
_0x6:
;      93 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;      94 
;      95 
;      96 //     0.
;      97 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;      98 {
_timer0_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;      99   owf_flag++; //   
	INC  R3
;     100   if(owf_flag > LIMIT) {
	LDI  R30,LOW(253)
	CP   R30,R3
	BRSH _0x9
;     101                         Int_Marker = FREE;
	CLR  R5
;     102                         completed_flag = FREE;   // ,     .
	CLR  R2
;     103                         owf_flag = 0;
	CLR  R3
;     104                         TIMSK CLR_B(6); //   ,   Compare A Match
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
;     105                        }
;     106 }
_0x9:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;     107 
;     108 
;     109 //  ,     ,   OCR1A.
;     110 interrupt [TIM1_COMPA] void timer1_compa_isr(void)
;     111 {
_timer1_compa_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     112  PORTD INV_B(4);
	IN   R30,0x12
	LDI  R26,LOW(16)
	EOR  R30,R26
	OUT  0x12,R30
;     113 
;     114   if(completed_flag == SET)  {
	LDI  R30,LOW(238)
	CP   R30,R2
	BRNE _0xA
;     115                              temp = dobavka;          //   ,   temp
	MOVW R6,R8
;     116                              completed_flag = FREE;   //  ,   
	CLR  R2
;     117                              }
;     118 
;     119 
;     120   if((compA + temp) > 0xFFFF ) {  // ,           FFFF
_0xA:
	MOVW R26,R6
	ADD  R26,R10
	ADC  R27,R11
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0xB
;     121                                    compA = ((compA + temp) - 0xFFFF); //  ,     .
	MOVW R30,R6
	ADD  R30,R10
	ADC  R31,R11
	SUBI R30,LOW(65535)
	SBCI R31,HIGH(65535)
	MOVW R10,R30
;     122                         } else {
	RJMP _0xC
_0xB:
;     123                                    compA =  (compA + temp);   //   -  .
	__ADDWRR 10,11,6,7
;     124                                }
_0xC:
;     125    OCR1A = compA;   //      .
	__OUTWR 10,11,42
;     126 
;     127 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;     128 
;     129 
;     130 void Measurement(void) {
_Measurement:
;     131 
;     132            if(Int_Start_Time < Int_Stop_Time) {
	LDS  R30,_Int_Stop_Time
	LDS  R31,_Int_Stop_Time+1
	CP   R12,R30
	CPC  R13,R31
	BRSH _0xD
;     133                                                Result = Int_Stop_Time - Int_Start_Time;
	SUB  R30,R12
	SBC  R31,R13
	RJMP _0xE6
;     134                                               }
;     135                                          else {
_0xD:
;     136                                                Result = (0xFFFF - Int_Start_Time) + Int_Stop_Time;
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	SUB  R30,R12
	SBC  R31,R13
	LDS  R26,_Int_Stop_Time
	LDS  R27,_Int_Stop_Time+1
	ADD  R30,R26
	ADC  R31,R27
_0xE6:
	STS  _Result,R30
	STS  _Result+1,R31
;     137                                               }
;     138 
;     139       Int_Marker = FREE;           // ,    .
	CLR  R5
;     140 }
	RET
;     141 
;     142 
;     143 
;     144 void Basis_cycle(void) {
_Basis_cycle:
;     145         #asm("wdr")  //   
	wdr
;     146 
;     147        if(Int_Marker == SET) {   //   INT1 ...
	LDI  R30,LOW(238)
	CP   R30,R5
	BRNE _0xF
;     148 
;     149        Measurement();  //    
	RCALL _Measurement
;     150 
;     151 
;     152          dobavka = (unsigned int)( ((unsigned long)(Result / K_div) + 1)  >> 1);
	LDS  R30,_K_div
	LDS  R31,_K_div+1
	LDS  R22,_K_div+2
	LDS  R23,_K_div+3
	LDS  R26,_Result
	LDS  R27,_Result+1
	CLR  R24
	CLR  R25
	RCALL __CDF2
	RCALL __DIVF21
	RCALL __CFD1
	__ADDD1N 1
	RCALL __LSRD1
	MOVW R8,R30
;     153 
;     154 
;     155       if((TCCR1B == RANGE_250) && (Result > 31000) ) { //    ,  ;
	IN   R30,0x2E
	CPI  R30,LOW(0x3)
	BRNE _0x11
	LDS  R26,_Result
	LDS  R27,_Result+1
	CPI  R26,LOW(0x7919)
	LDI  R30,HIGH(0x7919)
	CPC  R27,R30
	BRSH _0x12
_0x11:
	RJMP _0x10
_0x12:
;     156                                                       TCCR1B = RANGE_15;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
;     157                                                       dobavka = dobavka*16; //   16
	MOVW R30,R8
	RCALL __LSLW4
	MOVW R8,R30
;     158                                                      }
;     159 
;     160       if((TCCR1B == RANGE_15) && (Result < 1200) )  { //    ,  ;
_0x10:
	IN   R30,0x2E
	CPI  R30,LOW(0x5)
	BRNE _0x14
	LDS  R26,_Result
	LDS  R27,_Result+1
	CPI  R26,LOW(0x4B0)
	LDI  R30,HIGH(0x4B0)
	CPC  R27,R30
	BRLO _0x15
_0x14:
	RJMP _0x13
_0x15:
;     161                                                      TCCR1B = RANGE_250;
	LDI  R30,LOW(3)
	OUT  0x2E,R30
;     162                                                      dobavka = dobavka/16; //   16
	MOVW R30,R8
	RCALL __LSRW4
	MOVW R8,R30
;     163                                                     }
;     164 
;     165           completed_flag = SET; //     ,     completed_flag.
_0x13:
	LDI  R30,LOW(238)
	MOV  R2,R30
;     166 
;     167 
;     168           } // end of "if(Int_Marker == SET)"
;     169 }
_0xF:
	RET
;     170 
;     171 
;     172 char Start_of_calibration(void) { //   ,  
_Start_of_calibration:
;     173 unsigned int counter;
;     174 unsigned char num;
;     175 unsigned char buf[6];
;     176 float temp32 = 0.0;
;     177 
;     178 counter = 0;
	SBIW R28,10
	LDI  R24,4
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x16*2)
	LDI  R31,HIGH(_0x16*2)
	RCALL __INITLOCB
	RCALL __SAVELOCR4
;	counter -> R16,R17
;	num -> R19
;	buf -> Y+8
;	temp32 -> Y+4
	__GETWRN 16,17,0
;     179 
;     180 while ( (counter < 2000) && (KNOPA == PRESSED) ) {  //    ,  2 .
_0x17:
	__CPWRN 16,17,2000
	BRSH _0x1A
	SBIS 0x16,0
	RJMP _0x1B
_0x1A:
	RJMP _0x19
_0x1B:
;     181                                            counter++;
	__ADDWRN 16,17,1
;     182                                            #asm("wdr")  //   
	wdr
;     183                                            delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     184                                            }
	RJMP _0x17
_0x19:
;     185           if( counter < 2000 ) return;  //  -   - 
	__CPWRN 16,17,2000
	BRSH _0x1C
	RCALL __LOADLOCR4
	ADIW R28,14
	RET
;     186 
;     187           LED = 1; //  
_0x1C:
	SBI  0x12,6
;     188 
;     189           while (KNOPA == PRESSED) { #asm("wdr") } //   
_0x1D:
	SBIC 0x16,0
	RJMP _0x1F
	wdr
	RJMP _0x1D
_0x1F:
;     190           delay_ms(250); // 
	LDI  R30,LOW(250)
	LDI  R31,HIGH(250)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     191             if(KNOPA == PRESSED) { //      - 
	SBIC 0x16,0
	RJMP _0x20
;     192                                   LED = 0; //  
	CBI  0x12,6
;     193                                   return;
	RCALL __LOADLOCR4
	ADIW R28,14
	RET
;     194                                  }
;     195 
;     196 // ***    ,            . ***
;     197 
;     198 
;     199          if( SOURCE_TYPE == 1 ) {  //    ( ),     .
_0x20:
	SBIS 0x16,7
	RJMP _0x21
;     200 
;     201          K_div = 1.0; //    
	__GETD1N 0x3F800000
	STS  _K_div,R30
	STS  _K_div+1,R31
	STS  _K_div+2,R22
	STS  _K_div+3,R23
;     202             #asm("sei")
	sei
;     203             while (KNOPA == NO_PRESSED) { //    ...
_0x22:
	SBIS 0x16,0
	RJMP _0x24
;     204                                           Basis_cycle(); //..    .
	RCALL _Basis_cycle
;     205                                         }
	RJMP _0x22
_0x24:
;     206 
;     207                LED = 0; //  
	CBI  0x12,6
;     208                while(Int_Marker != SET) { #asm("wdr") } //     
_0x25:
	LDI  R30,LOW(238)
	CP   R30,R5
	BREQ _0x27
	wdr
	RJMP _0x25
_0x27:
;     209             #asm("cli")
	cli
;     210               TIMSK CLR_B(6); //    Compare A Match,   
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
;     211 
;     212             Measurement();  //    
	RCALL _Measurement
;     213 
;     214             if(DAT_TYPE == 1)  { counter = 1497; }  // 10-. 
	SBIS 0x16,6
	RJMP _0x28
	__GETWRN 16,17,1497
;     215                          else  { counter = 2500; }  // 6-. 
	RJMP _0x29
_0x28:
	__GETWRN 16,17,2500
_0x29:
;     216 
;     217                           temp32 = (float)(counter / Result);
	LDS  R30,_Result
	LDS  R31,_Result+1
	MOVW R26,R16
	RCALL __DIVW21U
	CLR  R22
	CLR  R23
	RCALL __CDF1
	__PUTD1S 4
;     218 
;     219                              } else {     //    -    UART
	RJMP _0x2A
_0x21:
;     220 
;     221                              // USART initialization
;     222                              // Communication Parameters: 8 Data, 1 Stop, No Parity
;     223                              // USART Receiver: On
;     224                              // USART Transmitter: Off
;     225                              // USART Mode: Asynchronous
;     226                              // USART Baud Rate: 19200
;     227                                     UCSRA=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
;     228                                     UCSRB=0x10;
	LDI  R30,LOW(16)
	OUT  0xA,R30
;     229                                     UCSRC=0x06;
	LDI  R30,LOW(6)
	OUT  0x3,R30
;     230                                     UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x2,R30
;     231                                     UBRRL=0x33;
	LDI  R30,LOW(51)
	OUT  0x9,R30
;     232 
;     233                                     buf[0] = getchar();
	RCALL _getchar
	STD  Y+8,R30
;     234                                     buf[1] = getchar();
	RCALL _getchar
	STD  Y+9,R30
;     235                                     buf[2] = getchar();
	RCALL _getchar
	STD  Y+10,R30
;     236                                     buf[3] = getchar();
	RCALL _getchar
	STD  Y+11,R30
;     237                                     buf[4] = getchar();
	RCALL _getchar
	STD  Y+12,R30
;     238                                     buf[5] = getchar();
	RCALL _getchar
	STD  Y+13,R30
;     239 
;     240                                  LED = 0; //  
	CBI  0x12,6
;     241 
;     242                                     if((buf[0] == 0xA5) && (buf[5] == 0x5A) ) {
	LDD  R26,Y+8
	CPI  R26,LOW(0xA5)
	BRNE _0x2C
	LDD  R26,Y+13
	CPI  R26,LOW(0x5A)
	BREQ _0x2D
_0x2C:
	RJMP _0x2B
_0x2D:
;     243                                                                                temp32 = *(float*)(&(buf[1]));   //     temp32
	__GETD1S 9
	__PUTD1S 4
;     244                                                                               }
;     245                                     UCSRB=0x00;  //  UART
_0x2B:
	LDI  R30,LOW(0)
	OUT  0xA,R30
;     246                                     }
_0x2A:
;     247 
;     248             if((temp32 > 0.30)&&(temp32 <= 3.0)) { //     ,    .
	__GETD2S 4
	__GETD1N 0x3E99999A
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x2F
	__GETD1N 0x40400000
	RCALL __CMPF12
	BREQ PC+3
	BRCS PC+2
	RJMP _0x2F
	RJMP _0x30
_0x2F:
	RJMP _0x2E
_0x30:
;     249                                                   division_factor = temp32;
	__GETD1S 4
	LDI  R26,LOW(_division_factor)
	LDI  R27,HIGH(_division_factor)
	RCALL __EEPROMWRD
;     250                                                  }
;     251                                             else {
	RJMP _0x31
_0x2E:
;     252                                                    #asm("wdr")                 // ... .
	wdr
;     253                                                    LED = 0; //  
	CBI  0x12,6
;     254                                                    return;
	RCALL __LOADLOCR4
	ADIW R28,14
	RET
;     255                                                  }
_0x31:
;     256 
;     257 
;     258 // ***     -   3 . ***
;     259 
;     260 num = 6;
	LDI  R19,LOW(6)
;     261 while (num) {
_0x32:
	CPI  R19,0
	BREQ _0x34
;     262              PORTD INV_B(6);  //   .
	IN   R30,0x12
	LDI  R26,LOW(64)
	EOR  R30,R26
	OUT  0x12,R30
;     263              num--;
	SUBI R19,1
;     264              #asm("wdr")  //   
	wdr
;     265              delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     266             }
	RJMP _0x32
_0x34:
;     267  LED = 0; //  
	CBI  0x12,6
;     268  return;
	RCALL __LOADLOCR4
	ADIW R28,14
	RET
;     269 }
;     270 
;     271 
;     272 void main(void)
;     273 {
_main:
;     274 // Declare your local variables here
;     275 
;     276 // Crystal Oscillator division factor: 1
;     277 #pragma optsize-
;     278 CLKPR=0x80;
	LDI  R30,LOW(128)
	OUT  0x26,R30
;     279 CLKPR=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
;     280 #ifdef _OPTIMIZE_SIZE_
;     281 #pragma optsize+
;     282 #endif
;     283 
;     284 // Input/Output Ports initialization
;     285 // Port A initialization
;     286 // Func2=In Func1=Out Func0=In
;     287 // State2=P State1=0 State0=T
;     288 PORTA=0x04;
	LDI  R30,LOW(4)
	OUT  0x1B,R30
;     289 DDRA=0x02;
	LDI  R30,LOW(2)
	OUT  0x1A,R30
;     290 
;     291 // Port B initialization
;     292 // Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=In
;     293 // State7=P State6=P State5=0 State4=0 State3=0 State2=0 State1=0 State0=T
;     294 PORTB=0xC0;
	LDI  R30,LOW(192)
	OUT  0x18,R30
;     295 DDRB=0x3E;
	LDI  R30,LOW(62)
	OUT  0x17,R30
;     296 
;     297 // Port D initialization
;     298 // Func6=Out Func5=Out Func4=Out Func3=In Func2=Out Func1=Out Func0=In
;     299 // State6=0 State5=1 State4=0 State3=T State2=0 State1=0 State0=T
;     300 PORTD=0x20;
	LDI  R30,LOW(32)
	OUT  0x12,R30
;     301 DDRD=0x76;
	LDI  R30,LOW(118)
	OUT  0x11,R30
;     302 
;     303 // Timer/Counter 0 initialization
;     304 // Clock source: System Clock
;     305 // Clock value: 15,625 kHz
;     306 // Mode: Normal top=FFh
;     307 // OC0A output: Disconnected
;     308 // OC0B output: Disconnected
;     309 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     310 TCCR0B=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
;     311 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     312 OCR0A=0x00;
	OUT  0x36,R30
;     313 OCR0B=0x00;
	OUT  0x3C,R30
;     314 
;     315 // Timer/Counter 1 initialization
;     316 // Clock source: System Clock
;     317 // Clock value: 250,000 kHz
;     318 // Mode: Normal top=FFFFh
;     319 // OC1A output: Discon.
;     320 // OC1B output: Discon.
;     321 // Noise Canceler: Off
;     322 // Input Capture on Falling Edge
;     323 // Timer 1 Overflow Interrupt: On
;     324 // Input Capture Interrupt: Off
;     325 // Compare A Match Interrupt: On
;     326 // Compare B Match Interrupt: Off
;     327 TCCR1A=0x00;
	OUT  0x2F,R30
;     328 TCCR1B=0x03;
	LDI  R30,LOW(3)
	OUT  0x2E,R30
;     329 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     330 TCNT1L=0x00;
	OUT  0x2C,R30
;     331 ICR1H=0x00;
	OUT  0x25,R30
;     332 ICR1L=0x00;
	OUT  0x24,R30
;     333 OCR1AH=(START_SET>>8);
	LDI  R30,LOW(128)
	OUT  0x2B,R30
;     334 OCR1AL=(START_SET & 0xFF);
	LDI  R30,LOW(1)
	OUT  0x2A,R30
;     335 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
;     336 OCR1BL=0x00;
	OUT  0x28,R30
;     337 
;     338 // External Interrupt(s) initialization
;     339 // INT0: Off
;     340 // INT1: On
;     341 // INT1 Mode: Falling Edge
;     342 // Interrupt on any change on pins PCINT0-7: Off
;     343 GIMSK=0x80;
	LDI  R30,LOW(128)
	OUT  0x3B,R30
;     344 MCUCR=0x08;
	LDI  R30,LOW(8)
	OUT  0x35,R30
;     345 EIFR=0x80;
	LDI  R30,LOW(128)
	OUT  0x3A,R30
;     346 
;     347 // Timer(s)/Counter(s) Interrupt(s) initialization
;     348 TIMSK=0x42;
	LDI  R30,LOW(66)
	OUT  0x39,R30
;     349 TIMSK CLR_B(6); //    .
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
;     350 
;     351 // Universal Serial Interface initialization
;     352 // Mode: Disabled
;     353 // Clock source: Register & Counter=no clk.
;     354 // USI Counter Overflow Interrupt: Off
;     355 USICR=0x00;
	LDI  R30,LOW(0)
	OUT  0xD,R30
;     356 
;     357 // Analog Comparator initialization
;     358 // Analog Comparator: Off
;     359 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     360 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     361 
;     362 // Watchdog Timer initialization
;     363 // Watchdog Timer Prescaler: OSC/1024k
;     364 // Watchdog Timer interrupt: Off
;     365 #pragma optsize-
;     366 WDTCR=0x39;
	LDI  R30,LOW(57)
	OUT  0x21,R30
;     367 WDTCR=0x29;
	LDI  R30,LOW(41)
	OUT  0x21,R30
;     368 #ifdef _OPTIMIZE_SIZE_
;     369 #pragma optsize+
;     370 #endif
;     371 
;     372 
;     373 if(KNOPA == PRESSED) { Start_of_calibration(); } //    -   
	SBIS 0x16,0
	RCALL _Start_of_calibration
;     374 
;     375  /*
;     376 if( SOURCE_TYPE == 1 ) { K_div = division_factor; } //    ( ),    
;     377                   else { K_div = FLASH_VAL; }            //    -   .
;     378 */
;     379 
;     380 K_div = division_factor;  //    
	LDI  R26,LOW(_division_factor)
	LDI  R27,HIGH(_division_factor)
	RCALL __EEPROMRDD
	STS  _K_div,R30
	STS  _K_div+1,R31
	STS  _K_div+2,R22
	STS  _K_div+3,R23
;     381 
;     382 
;     383 // Global enable interrupts
;     384 #asm("sei")
	sei
;     385 
;     386 while (1)
_0x36:
;     387       {
;     388       Basis_cycle();
	RCALL _Basis_cycle
;     389       }
	RJMP _0x36
;     390 }
_0x39:
	RJMP _0x39

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET

_isdigit:
	ldi  r30,1
	ld   r31,y+
	cpi  r31,'0'
	brlo __isdigit0
	cpi  r31,'9'+1
	brlo __isdigit1
__isdigit0:
	clr  r30
__isdigit1:
	ret

_isspace:
	ldi  r30,1
	ld   r31,y+
	cpi  r31,' '
	breq __isspace1
	cpi  r31,9
	brlo __isspace0
	cpi  r31,14
	brlo __isspace1
__isspace0:
	clr  r30
__isspace1:
	ret

_isxdigit:
	ldi  r30,1
	ld   r31,y+
	subi r31,0x30
	brcs __isxdigit0
	cpi  r31,10
	brcs __isxdigit1
	andi r31,0x5f
	subi r31,7
	cpi  r31,10
	brcs __isxdigit0
	cpi  r31,16
	brcs __isxdigit1
__isxdigit0:
	clr  r30
__isxdigit1:
	ret

_strlen:
	clr  r27
	ld   r26,y+
	clr  r30
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	inc  r30
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__LSRW4:
	LSR  R31
	ROR  R30
__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__LSRD1:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDD:
	ADIW R26,2
	RCALL __EEPROMRDW
	MOV  R23,R31
	MOV  R22,R30
	SBIW R26,2

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRD:
	RCALL __EEPROMWRW
	ADIW R26,2
	MOV  R0,R30
	MOV  R1,R31
	MOV  R30,R22
	MOV  R31,R23
	RCALL __EEPROMWRW
	MOV  R30,R0
	MOV  R31,R1
	SBIW R26,2
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIC EECR,EEWE
	RJMP __EEPROMWRB
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
